#include <windows.h>
#include <commctrl.h>
#include "section_2_4.h"

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

static char gszClassName[]  = "MyWindowClass";
static HINSTANCE ghInstance = NULL;
HWND   ghStatBar;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
        WNDCLASSEX WndClass;
        HWND hwnd;
        MSG Msg;

        ghInstance = hInstance;

        WndClass.cbSize        = sizeof(WNDCLASSEX);
        WndClass.style         = NULL;
        WndClass.lpfnWndProc   = WndProc;
        WndClass.cbClsExtra    = 0;
        WndClass.cbWndExtra    = 0;
        WndClass.hInstance     = ghInstance;
        WndClass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
        WndClass.hCursor       = LoadCursor(NULL, IDC_ARROW);
        WndClass.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
        WndClass.lpszMenuName  = NULL;
        WndClass.lpszClassName = gszClassName;
        WndClass.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);

        if(!RegisterClassEx(&WndClass)) {
                MessageBox(0, "Window Registration Failed!", "Error!", MB_ICONSTOP | MB_OK);
                return 0;
        }

        hwnd = CreateWindowEx(
                WS_EX_STATICEDGE,
                gszClassName,
                "Windows Title",
                WS_OVERLAPPEDWINDOW,
                CW_USEDEFAULT, CW_USEDEFAULT,
                320, 240,
                NULL, NULL,
                ghInstance,
                NULL);

        if(hwnd == NULL) {
                MessageBox(0, "Window Creation Failed!", "Error!", MB_ICONSTOP | MB_OK);
                return 0;
        }

        ShowWindow(hwnd, nCmdShow);
        UpdateWindow(hwnd);

        while(GetMessage(&Msg, NULL, 0, 0)) {
                TranslateMessage(&Msg);
                DispatchMessage(&Msg);
        }
        return Msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam) {
        switch(Message) {
                case WM_CREATE:
                        int iBarWidths[] = {100, 200, 300, -1};
   
                        InitCommonControls();

                        ghStatBar = CreateWindowEx(
                                NULL,
                                STATUSCLASSNAME,
                                NULL,
                                WS_CHILD | WS_VISIBLE | SBARS_SIZEGRIP,
                                0, 0,
                                0, 0,
                                hwnd, (HMENU)IDC_STATBAR,
                                ghInstance,
                                NULL);
                        SendMessage(ghStatBar, SB_SETPARTS, 4, (LPARAM) iBarWidths);

                        SendMessage(ghStatBar, SB_SETTEXT, 0, (LPARAM) "Part 1");
                        SendMessage(ghStatBar, SB_SETTEXT, 1, (LPARAM) "Part 2");
                        SendMessage(ghStatBar, SB_SETTEXT, 2, (LPARAM) "Part 3");
                        SendMessage(ghStatBar, SB_SETTEXT, 3, (LPARAM) "Part 4");
                        break;
                case WM_SIZE:
                        SendMessage(ghStatBar, WM_SIZE, 0, 0);
                        break;
                case WM_CLOSE:
                        DestroyWindow(hwnd);
                        break;
                case WM_DESTROY:
                        PostQuitMessage(0);
                        break;
                default:
                        return DefWindowProc(hwnd, Message, wParam, lParam);
        }
        return 0;
} 